Subject: 27.0.50; Mac OS Catalina random crashes

From: Marcin Korecki <[email-masked]>
Date: Sun, 15 Dec 2019 12:39:37 +0000

I've been experiencing a weird problem. Ever since updating to catalina my emacs crashes at random intervals. It seems that there is no rule (or I cannot see it) to when it happens. The frequency is quite high but there is no specific thing I do before it happens. I have tried removing parts of my config which could be responsible but so far no matter what I remove it keeps on happening. I tried different versions of emacs: emacs for mac OS, emacs installed via homebrew and I'm now using a version I built myself, on all those versions the problem persists.

I have created a thread about it on emacs.stackexchange.com -
https://emacs.stackexchange.com/questions/54232/mac-os-catalina-random-crash?noredirect=1#comment84911_54232. One
person seems to be investigating the causes and has identified a memory
leak relating to mach ports and opening files living in icloud
drive. Here is a stack trace from the crash:

Thread 0 Crashed:: Dispatch queue: com.apple.main-thread
0   libsystem_kernel.dylib          0x00007fff6ab1c49a __pthread_kill + 10
1   libsystem_pthread.dylib         0x00007fff6abd96cb pthread_kill + 384
2   libsystem_c.dylib               0x00007fff6aa343a2 raise + 26
3   org.gnu.Emacs                   0x000000010d6bd319 terminate_due_to_signal + 153
4   org.gnu.Emacs                   0x000000010d6bdc5b emacs_abort + 15
5   org.gnu.Emacs                   0x000000010d685bf0 ns_term_shutdown + 80
6   org.gnu.Emacs                   0x000000010d57bab4 shut_down_emacs + 340
7   org.gnu.Emacs                   0x000000010d6bd2e6 terminate_due_to_signal + 102
8   org.gnu.Emacs                   0x000000010d59acae 0x10d4bd000 + 908462
9   libsystem_platform.dylib        0x00007fff6abceb1d _sigtramp + 29
10  ???                             000000000000000000 0 + 0
11  com.apple.CoreFoundation        0x00007fff334f436b __CFRunLoopServiceMachPort + 322
12  com.apple.CoreFoundation        0x00007fff334f3907 __CFRunLoopRun + 1695
13  com.apple.CoreFoundation        0x00007fff334f2fe3 CFRunLoopRunSpecific + 499
14  com.apple.HIToolbox             0x00007fff3207a67d RunCurrentEventLoopInMode + 292
15  com.apple.HIToolbox             0x00007fff3207a3bd ReceiveNextEventCommon + 600
16  com.apple.HIToolbox             0x00007fff3207a147 _BlockUntilNextEventMatchingListInModeWithFilter + 64
17  com.apple.AppKit                0x00007fff306ff864 _DPSNextEvent + 990
18  com.apple.AppKit                0x00007fff306fe5d4 -[NSApplication(NSEvent) _nextEventMatchingEventMask:untilDate:inMode:dequeue:] + 1352
19  com.apple.AppKit                0x00007fff306f8d76 -[NSApplication run] + 658
20  org.gnu.Emacs                   0x000000010d685dad 0x10d4bd000 + 1871277
21  org.gnu.Emacs                   0x000000010d684a11 ns_select + 897
22  org.gnu.Emacs                   0x000000010d654292 wait_reading_process_output + 3570
23  org.gnu.Emacs                   0x000000010d4c4f08 sit_for + 312
24  org.gnu.Emacs                   0x000000010d5841c6 read_char + 5222
25  org.gnu.Emacs                   0x000000010d5811da 0x10d4bd000 + 803290
26  org.gnu.Emacs                   0x000000010d57f9dc command_loop_1 + 1308
27  org.gnu.Emacs                   0x000000010d6065d7 internal_condition_case + 263
28  org.gnu.Emacs                   0x000000010d58fa80 0x10d4bd000 + 862848
29  org.gnu.Emacs                   0x000000010d605deb internal_catch + 267
30  org.gnu.Emacs                   0x000000010d6bd6e5 0x10d4bd000 + 2098917
31  org.gnu.Emacs                   0x000000010d57eac3 0x10d4bd000 + 793283
32  org.gnu.Emacs                   0x000000010d57e9f3 recursive_edit_1 + 115
33  org.gnu.Emacs                   0x000000010d57ec4b Frecursive_edit + 347
34  org.gnu.Emacs                   0x000000010d57d827 main + 7431
35  libdyld.dylib                   0x00007fff6a9cd2e5 start + 1

Due to the irregular character of the crash I have not had luck in
catching it with a gdb but I will try to do that and send it when
it happens.

In GNU Emacs 27.0.50 (build 1, x86_64-apple-darwin19.0.0, NS appkit-1894.10 Version 10.15.1 (Build 19B88))
of 2019-11-17 built on pc-78-18.customer.ask4.lan
Repository revision: 3dcf06bfa035c3caaeac5ce5c585dbfc07f31331
Repository branch: master
Windowing system distributor 'Apple', version 10.3.1894
System Description:  Mac OS X 10.15.2

Recent messages:
Checking 71 files in /Applications/Emacs.app/Contents/Resources/lisp/erc...
Checking 34 files in /Applications/Emacs.app/Contents/Resources/lisp/emulation...
Checking 180 files in /Applications/Emacs.app/Contents/Resources/lisp/emacs-lisp...
Checking 24 files in /Applications/Emacs.app/Contents/Resources/lisp/cedet...
Checking 59 files in /Applications/Emacs.app/Contents/Resources/lisp/calendar...
Checking 87 files in /Applications/Emacs.app/Contents/Resources/lisp/calc...
Checking 113 files in /Applications/Emacs.app/Contents/Resources/lisp/obsolete...
Checking for load-path shadows...done
End of buffer [6 times]
Beginning of buffer [4 times]
kill-buffer-and-window: Attempt to delete main window of frame #<frame *Bug Help* 0x7fd9eb150630>
Configured using:
'configure --with-ns --with-modules --enable-silent-rules
PKG_CONFIG_PATH=/opt/local/lib/pkgconfig LDFLAGS=-L/opt/local/lib
CPPFLAGS=-I/opt/local/include CC=clang OBJC=clang 'CFLAGS=-g -O2'
--with-gnutls=ifavailable'

Configured features:
NOTIFY KQUEUE ACL LIBXML2 ZLIB TOOLKIT_SCROLL_BARS NS MODULES THREADS
PDUMPER GMP

Important settings:
  value of $LANG: en_PL.UTF-8
  locale-coding-system: utf-8-unix

Major mode: C++//l

Minor modes in effect:
  shell-dirtrack-mode: t
  mac-key-mode: t
  desktop-save-mode: t
  delete-selection-mode: t
  global-linum-mode: t
  linum-mode: t
  smart-tabs-mode: t
  global-auto-complete-mode: t
  auto-complete-mode: t
  tabbar-mwheel-mode: t
  tabbar-mode: t
  show-paren-mode: t
  global-ede-mode: t
  ede-minor-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t
  abbrev-mode: t

Load-path shadows:
None found.

Features:
(pp shadow sort mail-extr emacsbug message rmc puny dired dired-loaddefs
rfc822 mml mml-sec epa derived epg epg-config gnus-util rmail
rmail-loaddefs text-property-search mm-decode mm-bodies mm-encode
mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047
rfc2045 ietf-drums mm-util mail-prsvr mail-utils make-mode vc-git
diff-mode image-mode exif cc-mode cc-fonts cc-guess cc-menus cc-cmds
cc-styles cc-align cc-engine cc-vars cc-defs cl-extra help-mode
flymake-proc flymake compile warnings thingatpt python tramp-sh tramp
tramp-loaddefs trampver tramp-integration files-x tramp-compat shell
pcomplete parse-time iso8601 time-date ls-lisp format-spec comint ring
ansi-color mac-key-mode redo+ desktop frameset delsel all-the-icons
all-the-icons-faces data-material data-weathericons data-octicons
data-fileicons data-faicons data-alltheicons memoize hl-line neotree
exec-path-from-shell linum smart-tabs-mode advice auto-complete edmacro
kmacro popup light-blue-theme tabbar easy-mmode paren ede/speedbar
ede/files ede ede/detect ede/base ede/auto ede/source eieio-base
eieio-speedbar speedbar sb-image ezimage dframe eieio-custom wid-edit
cedet cus-start cus-load finder-inf info package easymenu browse-url
url-handlers url-parse auth-source cl-seq eieio eieio-core cl-macs
eieio-loaddefs password-cache json subr-x map url-vars seq byte-opt gv
bytecomp byte-compile cconv cl-loaddefs cl-lib tooltip eldoc electric
uniquify ediff-hook vc-hooks lisp-float-type mwheel term/ns-win ns-win
ucs-normalize mule-util term/common-win tool-bar dnd fontset image
regexp-opt fringe tabulated-list replace newcomment text-mode elisp-mode
lisp-mode prog-mode register page tab-bar menu-bar rfn-eshadow isearch
timer select scroll-bar mouse jit-lock font-lock syntax facemenu
font-core term/tty-colors frame minibuffer cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote threads kqueue cocoa ns
multi-tty make-network-process emacs)

Memory information:
((conses 16 181887 21452)
(symbols 48 18543 2)
(strings 32 62228 3089)
(string-bytes 1 1931213)
(vectors 16 31400)
(vector-slots 8 645741 32234)
(floats 8 459 289)
(intervals 56 1229 249)
(buffers 1000 22))